const { upload } = require("./uploader");
const { merge } = require("webpack-merge");
const webpack = require("webpack");

exports.default = {
  post: upload,
  config: function (cfg) {
    // Parse the --configuration argument
    const args = process.argv.slice(2);

    let configuration;
    const configIndex = args.indexOf("--configuration");
    if (configIndex !== -1 && args[configIndex + 1]) {
      configuration = args[configIndex + 1];
    }

    const isDevelopment = configuration === "development";

    if (isDevelopment) {
      console.log("Inlining sourcemaps");
    }

    const result = merge(cfg, {
      // Only inline source maps if in development
      devtool: isDevelopment ? "inline-source-map" : false
    });

    // Remove SourceMapDevToolPlugin if it exists
    const index = result.plugins.findIndex((plugin) => {
      return plugin instanceof webpack.SourceMapDevToolPlugin;
    });
    if (index !== -1) {
      result.plugins.splice(index, 1);
    }

    return result;
  }
};
